/* 
 *
 * $Id: k3bmonkeyio.h,v 1.1.1.1 2004/03/09 21:34:16 trueg Exp $
 * Copyright (C) 2003 Sebastian Trueg <trueg@k3b.org>
 *
 * This file is part of the K3b project.
 * Copyright (C) 1998-2003 Sebastian Trueg <trueg@k3b.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#ifndef _K3B_MONKEY_IO_H_
#define _K3B_MONKEY_IO_H_


#include <All.h>
#include <MACLib.h>
#include <CharacterHelper.h>
#include <IO.h>

#include <wchar.h>

#include <qstring.h>

/**
 * IO class needed to fix the endianess issues
 * with the Monkey Audio SDK.
 *
 * For some reason it it sufficient to simply use
 * QFile as a backend.
 * FIXME: Do we need to swap bytes on big endian machines??
 */
class K3bMonkeyIO : public CIO
{
 public:

  K3bMonkeyIO();
  ~K3bMonkeyIO();

  int Open(const wchar_t * pName);
  int Open(const QString& pName);
  int Close();
	
  int Read(void * pBuffer, unsigned int nBytesToRead, unsigned int * pBytesRead);
  int Write(const void * pBuffer, unsigned int nBytesToWrite, unsigned int * pBytesWritten);
	
  int Seek(int nDistance, unsigned int nMoveMode);
	
  int Create(const wchar_t * pName);
  int Create(const char * pName);
  int Delete();

  int SetEOF();

  int GetPosition();
  int GetSize();
  int GetName(wchar_t * pBuffer);
  int GetName(char * pBuffer);

 private:
  class Private;
  Private* d;
};

#endif
